remove vbuild scripts
authorThierry Parmentelat <thierry.parmentelat@inria.fr>
Thu, 30 Jan 2014 17:24:07 +0000 (18:24 +0100)
committerThierry Parmentelat <thierry.parmentelat@inria.fr>
Thu, 30 Jan 2014 17:24:07 +0000 (18:24 +0100)
vbuild-initvm.sh [deleted file]
vbuild-nightly.sh [deleted file]

diff --git a/vbuild-initvm.sh b/vbuild-initvm.sh
deleted file mode 100755 (executable)
index 5eb58f6..0000000
+++ /dev/null
@@ -1,619 +0,0 @@
-#!/bin/bash
-# -*-shell-*-
-
-#shopt -s huponexit
-
-COMMAND=$(basename $0)
-DIRNAME=$(dirname $0)
-
-# pkgs parsing utilities
-PATH=$(dirname $0):$PATH export PATH
-. build.common
-
-DEFAULT_FCDISTRO=f14
-DEFAULT_PLDISTRO=planetlab
-DEFAULT_PERSONALITY=linux64
-DEFAULT_IFNAME=eth0
-
-COMMAND_VBUILD="vbuild-initvm.sh"
-COMMAND_MYPLC="vtest-initvm.sh"
-
-function failure () {
-    echo "$COMMAND : Bailing out"
-    exit 1
-}
-
-# overwrite vserver's internal yum config from what is in
-# .distributions/<distrib>/yum/yum.conf and /yum.repos.d 
-
-function configure_yum_in_vserver () {
-    set -x 
-    set -e 
-    trap failure ERR INT
-
-    vserver=$1; shift
-    fcdistro=$1; shift
-    pldistro=$1; shift
-
-    templates=/etc/vservers/.distributions/${fcdistro}
-    if [ -f ${templates}/yum/yum.conf ] ; then
-       echo "Initializing yum.conf in $vserver from ${templates}/yum"
-        sed -e "s!@YUMETCDIR@!/etc!g;
-                s!@YUMCACHEDIR@!/var/cache/yum!g;
-                s!@YUMLOGDIR@!/var/log!g;
-                s!@YUMLOCKDIR@!/var/lock!g;
-               " ${templates}/yum/yum.conf > /vservers/$vserver/etc/yum.conf
-
-       # post process the various @...@ variables from this yum.conf file.
-    else
-       echo "Using $fcdistro default for yum.conf"
-    fi
-
-    if [ -d ${templates}/yum.repos.d ] ; then
-       echo "Initializing yum.repos.d in $vserver from ${templates}/yum.repos.d"
-       rm -rf /vservers/$vserver/etc/yum.repos.d
-       tar -C ${templates} -cf - yum.repos.d | tar -C /vservers/$vserver/etc -xvf -
-    else
-       echo "Cannot initialize yum.repos.d in $vserver"
-    fi
-
-    # for using vtest-init-vserver.sh as a general-purpose vserver creation wrapper
-    # just mention 'none' as the repo url
-    if [ -n "$MYPLC_MODE" -a "$REPO_URL" != "none" ] ; then
-       if [ ! -d /vservers/$vserver/etc/yum.repos.d ] ; then
-           echo "WARNING : cannot create myplc repo"
-       else
-            # exclude kernel from fedora repos 
-           yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
-           for repo in /vservers/$vserver/etc/yum.repos.d/* ; do
-               [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude" 
-           done
-           # the build repo is not signed at this stage
-           cat > /vservers/$vserver/etc/yum.repos.d/myplc.repo <<EOF
-[myplc]
-name= MyPLC
-baseurl=$REPO_URL
-enabled=1
-gpgcheck=0
-EOF
-       fi
-    fi
-}    
-
-# return yum or debootstrap
-function package_method () {
-    fcdistro=$1; shift
-    case $fcdistro in
-       f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
-       squeeze|wheezy|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
-       *) echo Unknown distro $fcdistro ;;
-    esac 
-}
-
-# need to specify the right mirror for debian variants like ubuntu and the like
-function debian_mirror () {
-    fcdistro=$1; shift
-    case $fcdistro in
-       squeeze|wheezy) 
-           echo http://ftp2.fr.debian.org/debian/ ;;
-       oneiric|precise|quantal|raring|saucy) 
-           echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
-       *) echo unknown distro $fcdistro; exit 1;;
-    esac
-}
-
-
-
-# return arch from debian distro and personality
-function canonical_arch () {
-    personality=$1; shift
-    fcdistro=$1; shift
-    case $(package_method $fcdistro) in
-       yum)
-           case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
-       debootstrap)
-           case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
-       *)
-           echo Unknown-arch-3 ;;
-    esac
-}
-
-# the new test framework creates /timestamp in /vservers/<name> *before* populating it
-function almost_empty () { 
-    dir="$1"; shift ; 
-    # non existing is fine
-    [ ! -d $dir ] && return 0; 
-    # need to have at most one file
-    count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
-}
-
-function setup_vserver () {
-
-    set -x
-    set -e
-    trap failure ERR INT
-
-    vserver=$1; shift
-    fcdistro=$1; shift
-    pldistro=$1; shift
-    personality=$1; shift
-
-    # check that this is a new one - see above
-    almost_empty /vservers/$vserver || {       
-       echo "$COMMAND : vserver $vserver seems to exist - bailing out"
-       exit 1
-       }
-
-    pkg_method=$(package_method $fcdistro)
-    case $pkg_method in
-       yum)
-           build_options="-m yum -- -d $fcdistro" 
-           ;;
-       debootstrap)
-           arch=$(canonical_arch $personality $fcdistro)
-           debmirror=$(debian_mirror $fcdistro)
-           build_options="-m debootstrap -- -d $fcdistro -m $debmirror -- --arch $arch"
-           ;;
-       *)
-           build_options="undefined-package_method" ;;
-    esac
-
-    # create it
-    # try to work around the vserver issue:
-    # vc_ctx_migrate: No such process
-    # rpm-fake.so: failed to initialize communication with resolver
-    for i in $(seq 20) ; do
-       $personality vserver $VERBOSE $vserver build $VSERVER_OPTIONS $build_options && break || true
-       echo "* ${i}-th attempt to 'vserver build' failed - waiting for 3 seconds"
-       sleep 3
-    done
-    # check success - not enough to check for the directory, let's assume /etc/ in image
-    [ -d /vservers/$vserver/etc ] 
-
-    if [ ! -z "$personality" ] ; then
-       if [ -f "/etc/vservers/$vserver/personality" ] ; then
-           registered_personality=$(grep $personality /etc/vservers/$vserver/personality | wc -l)
-       else
-           registered_personality=0
-       fi
-       if [ $registered_personality -eq 0 -a "$personality" != "linux64" ] ; then
-           echo $personality >> /etc/vservers/$vserver/personality
-       fi
-    fi
-
-    BCAPFILE=/etc/vservers/$vserver/bcapabilities
-    touch $BCAPFILE
-    if [ -n "$VBUILD_MODE" ] ; then 
-       ### capabilities required for a build vserver
-        # set up appropriate vserver capabilities to mount, mknod and IPC_LOCK
-       grep -q ^CAP_SYS_ADMIN $BCAPFILE || echo CAP_SYS_ADMIN >> $BCAPFILE
-       grep -q ^CAP_MKNOD $BCAPFILE || echo CAP_MKNOD >> $BCAPFILE
-       grep -q ^CAP_IPC_LOCK $BCAPFILE || echo CAP_IPC_LOCK >> $BCAPFILE
-       # useful for f16 guests that use set_cap_file 
-       grep -q ^CAP_SETFCAP $BCAPFILE || echo CAP_SETFCAP >> $BCAPFILE
-    else
-       ### capabilities required for a myplc vserver
-       # for /etc/plc.d/gpg - need to init /dev/random
-       grep -q ^CAP_MKNOD $BCAPFILE || echo CAP_MKNOD >> $BCAPFILE
-       grep -q ^CAP_NET_BIND_SERVICE $BCAPFILE || echo CAP_NET_BIND_SERVICE >> $BCAPFILE
-       # useful for f16 guests that use set_cap_file 
-       grep -q ^CAP_SETFCAP $BCAPFILE || echo CAP_SETFCAP >> $BCAPFILE
-    fi
-
-    # Set persistent for the network context
-    # Thierry: Daniel's kernels come with single_ip turned off by default, let's make this explicit 
-    echo "persistent,lback_allow,~single_ip" > /etc/vservers/$vserver/nflags
-
-    # Set cflags
-    echo -e "persistent\n~info_init" > /etc/vservers/$vserver/cflags
-
-    # Enable cgroup
-    mkdir /etc/vservers/$vserver/cgroup
-
-    # Set the init style of your vserver to plain for f16 and higher
-    # not working with f16 anyways, systemd requires 2.6.36 to work
-    case $fcdistro in 
-       f1[5-9]) echo plain > /etc/vservers/$vserver/apps/init/style ;;
-       f2?)     echo plain > /etc/vservers/$vserver/apps/init/style ;;
-    esac
-
-    if [ "$pkg_method" = "yum" ] ; then
-       $personality vyum $vserver -- -y install yum
-        # ditto
-       for i in $(seq 20) ; do
-           $personality vserver $VERBOSE $vserver pkgmgmt internalize && break || true
-           echo "* ${i}-th attempt to 'vserver pkgmgmt internalize' failed - waiting for 3 seconds"
-           sleep 3
-       done
-    fi
-    
-    # turns out that with wheezy at least, at this point we're getting 
-    # /vservers/<vs>/var/run -> /run
-    # /vservers/<vs>/var/lock -> /run/lock
-    # trying to fix this with relative links does not appear to work fine
-    # when trying to vserver start we're then getting
-    # + exec /usr/sbin/vspace --mount --fs --new -- /usr/sbin/vserver ----nonamespace debuild09 start
-    # fakerunlevel: open("/var/run/utmp"): No such file or directory
-    # so instead we bluntly create empty dirs and hope for the best
-#    if [ "$pkg_method" = "debootstrap" ] ; then
-       [ -h /vservers/$vserver/var/run ] && [ ! -d /vservers/$vserver/var/run ] && \
-#          { rm -f /vservers/$vserver/var/run ; ln -s ../run /vservers/$vserver/var/run ; }
-           { rm -f /vservers/$vserver/var/run ; mkdir /vservers/$vserver/var/run ; }
-       [ -h /vservers/$vserver/var/lock ] && [ ! -d /vservers/$vserver/var/lock ] && \
-#          { rm -f /vservers/$vserver/var/lock ; ln -s ../run/lock /vservers/$vserver/var/lock ; }
-           { rm -f /vservers/$vserver/var/lock ; mkdir /vservers/$vserver/var/lock ; }
-#    fi
-
-    # start the vserver so we can do the following operations
-    # redirect out/err to protect against the vserver's init sequence getting stalled 
-    # mostly used for f10 vservers created remotely through ssh
-    # with ubuntu/raring, somehow this fails, so ignore retcod, 
-    # as subsequent vserver exec will fail anyway
-    $personality vserver $VERBOSE $vserver start >& /dev/null || :
-
-    if [ "$pkg_method" == "yum" ] ; then
-       $personality vserver $VERBOSE $vserver exec sh -c "rm -f /var/lib/rpm/__db*"
-
-       # run the host rpmdb_dump and restore with the guest rpmdb_load
-       function translate_rpm_hashes () {
-           set -x
-           set -e
-           local personality="$1"; shift
-           local vserver="$1"; shift
-           # need to have utilities installed
-           type -p file
-           type -p awk
-           type -p cut
-           guest_dir=/var/lib/rpm
-           host_dir=/vservers/$vserver/$guest_dir
-           files=$(cd $host_dir ; file * | grep Hash | cut -d: -f 1)
-           for file in $files; do
-               (cd $host_dir && mv $file ${file}-foreign)
-               /usr/lib/rpm/rpmdb_dump $host_dir/${file}-foreign | $personality vserver $VERBOSE $vserver exec /usr/lib/rpm/rpmdb_load $guest_dir/$file
-           done
-           $personality vserver $VERBOSE $vserver exec rpm --rebuilddb
-           return 0
-       }
-
-       # try the simple way, if that fails try to cross fix the rpm hashes
-       $personality vserver $VERBOSE $vserver exec rpm --rebuilddb || translate_rpm_hashes $personality $vserver
-      
-    elif [ "$pkg_method" == "debootstrap" ] ; then
-       # just check the vm is running
-       $personality vserver $VERBOSE $vserver exec arch 
-    fi
-
-    # check if the vserver kernel is using VSERVER_DEVICE (vdevmap) support
-    need_vdevmap=$(grep "CONFIG_VSERVER_DEVICE=y" /boot/config-$(uname -r) | wc -l)
-
-    if [ $need_vdevmap -eq 1 ] ; then
-       ctx=$(cat /etc/vservers/$vserver/context)
-       vdevmap --set --xid $ctx --open --create --target /dev/null
-       vdevmap --set --xid $ctx --open --create --target /dev/root
-    fi
-           
-    # minimal config in the vserver for yum to work
-    [ "$pkg_method" = "yum" ] && configure_yum_in_vserver $vserver $fcdistro $pldistro
-
-    # set up resolv.conf
-    cp /etc/resolv.conf /vservers/$vserver/etc/resolv.conf
-    cp /etc/resolv.conf /vservers/$vserver/etc/resolv.conf.preserve
-    # and /etc/hosts for at least localhost
-    [ -f /vservers/$vserver/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > /vservers/$vserver/etc/hosts
-
-}
-
-function devel_or_vtest_tools () {
-
-    set -x 
-    set -e 
-    trap failure ERR INT
-
-    vserver=$1; shift
-    fcdistro=$1; shift
-    pldistro=$1; shift
-    personality=$1; shift
-
-    pkg_method=$(package_method $fcdistro)
-
-    pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
-
-    ### install individual packages, then groups
-    # get target arch - use uname -i here (we want either x86_64 or i386)
-    vserver_arch=$($personality vserver $vserver exec uname -i)
-    # on debian systems we get arch through the 'arch' command
-    [ "$vserver_arch" = "unknown" ] && vserver_arch=$($personality vserver $vserver exec arch)
-    
-    packages=$(pl_getPackages -a $vserver_arch $fcdistro $pldistro $pkgsfile)
-    groups=$(pl_getGroups -a $vserver_arch $fcdistro $pldistro $pkgsfile)
-
-    case "$pkg_method" in
-       yum)
-           [ -n "$packages" ] && $personality vserver $vserver exec yum -y install $packages
-           for group_plus in $groups; do
-               group=$(echo $group_plus | sed -e "s,+++, ,g")
-               $personality vserver $vserver exec yum -y groupinstall "$group"
-           done
-           # store current rpm list in /init-vserver.rpms in case we need to check the contents
-           $personality vserver $vserver exec rpm -aq > /vservers/$vserver/init-vserver.rpms
-           ;;
-       debootstrap)
-           # for ubuntu
-           if grep -iq ubuntu /vservers/$vserver/etc/lsb-release 2> /dev/null; then
-               # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
-               # we need at least to add the 'universe' feed for python-rpm
-               ( cd /vservers/$vserver/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
-               # also adding a link to updates sounds about right
-               ( cd /vservers/$vserver/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
-           fi
-           $personality vserver $vserver exec apt-get update
-           # ignore result because that one failed on precise
-sc         $personality vserver $vserver exec apt-get -y upgrade ||:
-           # handle this one firt off to be sure; mostly cosmetic but avoid a huge amount of warnings
-           $personality vserver $vserver exec apt-get install -y locales
-           $personality vserver $vserver exec locale-gen en_US.UTF-8
-           # install required packages
-           # all in a single batch 
-           [ -n "$packages" ] && $personality vserver $vserver exec apt-get install -y --ignore-missing $packages || :
-           # of course, on ubuntu apt-get --ignore-missing .. does not ignore missing packages !
-           # check it up a bit 
-           for package in $packages ; do 
-               if $personality vserver $vserver exec dpkg -l $package >& /dev/null ; then
-                   echo "==========(debian) package $package OK (1)"
-               else
-                   # try to install it individually - so this is for ubuntu
-                   $personality vserver $vserver exec apt-get install -y $package || :
-                   # still not there ?
-                   if $personality vserver $vserver exec dpkg -l $package >& /dev/null ; then
-                       echo "==========(debian) package $package OK (2)"
-                   else
-                       echo "==========(debian) package $package MISSING - ignored" 
-                   fi
-               fi
-           done
-           ### xxx todo install groups with apt..
-           ;;
-       *)
-           echo "unknown pkg_method $pkg_method"
-           ;;
-    esac
-
-    return 0
-}
-
-function post_install () {
-    if [ -n "$VBUILD_MODE" ] ; then
-       post_install_vbuild "$@" 
-    else
-       post_install_myplc "$@"
-    fi
-    # setup localtime from the host
-    vserver=$1; shift 
-    cp /etc/localtime /vservers/$vserver/etc/localtime
-}
-
-function post_install_vbuild () {
-
-    set -x 
-    set -e 
-    trap failure ERR INT
-
-    vserver=$1; shift
-    personality=$1; shift
-
-### From myplc-devel-native.spec
-# be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
-    cat << EOF | $personality vserver $VERBOSE $vserver exec bash -x
-    # set up /dev/loop* in vserver
-    for i in \$(seq 0 255) ; do
-       mknod -m 640 /dev/loop\$i b 7 \$i
-    done
-    
-    # create symlink for /dev/fd
-    [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
-
-    # modify /etc/rpm/macros to not use /sbin/new-kernel-pkg
-    sed -i 's,/sbin/new-kernel-pkg:,,' /etc/rpm/macros
-    if [ -h "/sbin/new-kernel-pkg" ] ; then
-       filename=\$(readlink -f /sbin/new-kernel-pkg)
-       if [ "\$filename" == "/sbin/true" ] ; then
-               echo "WARNING: /sbin/new-kernel-pkg symlinked to /sbin/true"
-               echo "\tmost likely /etc/rpm/macros has /sbin/new-kernel-pkg declared in _netsharedpath."
-               echo "\tPlease remove /sbin/new-kernel-pkg from _netsharedpath and reintall mkinitrd."
-               exit 1
-       fi
-    fi
-    
-    # customize root's prompt
-    cat << PROFILE > /root/.profile
-export PS1="[$vserver] \\w # "
-PROFILE
-
-    uid=2000
-    gid=2000
-    
-    # add a "build" user to the system
-    builduser=\$(grep "^build:" /etc/passwd | wc -l)
-    if [ \$builduser -eq 0 ] ; then
-       groupadd -o -g \$gid build;
-       useradd -o -c 'Automated Build' -u \$uid -g \$gid -n -M -s /bin/bash build;
-    fi
-
-# Allow build user to build certain RPMs as root
-    if [ -f /etc/sudoers ] ; then
-       buildsudo=\$(grep "^build.*ALL=(ALL).*NOPASSWD:.*ALL"  /etc/sudoers | wc -l)
-       if [ \$buildsudo -eq 0 ] ; then
-           echo "build   ALL=(ALL)       NOPASSWD: ALL" >> /etc/sudoers
-       fi
-        sed -i 's,^Defaults.*requiretty,#Defaults requiretty,' /etc/sudoers
-    fi
-#
-EOF
-
-}
-
-function post_install_myplc  () {
-    set -x 
-    set -e 
-    trap failure ERR INT
-
-    vserver=$1; shift
-    personality=$1; shift
-
-# be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
-    cat << EOF | $personality vserver $VERBOSE $vserver exec bash -x
-
-    # create /etc/sysconfig/network if missing
-    [ -f /etc/sysconfig/network ] || echo NETWORKING=yes > /etc/sysconfig/network
-
-    # create symlink for /dev/fd
-    [ ! -e "/dev/fd" ] && ln -s /proc/self/fd /dev/fd
-
-    # turn off regular crond, as plc invokes plc_crond
-    chkconfig crond off
-
-    # take care of loginuid in /etc/pam.d 
-    sed -i "s,#*\(.*loginuid.*\),#\1," /etc/pam.d/*
-
-    # customize root's prompt
-    cat << PROFILE > /root/.profile
-export PS1="[$vserver] \\w # "
-PROFILE
-
-EOF
-}
-
-# parses ifconfig's output to find out ip address and mask
-# will then be passed to vserver as e.g. --interface 138.96.250.126/255.255.0.0
-# default is to use lo, that's enough for local mirrors
-# use -i eth0 in case your fedora mirror is on a separate box on the network
-function vserverIfconfig () {
-    ifname=$1; shift
-    local result="" 
-    line=$(ifconfig $ifname 2> /dev/null | grep 'inet addr')
-    if [ -n "$line" ] ; then
-       set $line
-       for word in "$@" ; do
-           addr=$(echo $word | sed -e s,[aA][dD][dD][rR]:,,)
-           mask=$(echo $word | sed -e s,[mM][aA][sS][kK]:,,)
-           if [ "$word" != "$addr" ] ; then
-               result="${addr}"
-           elif [ "$word" != "$mask" ] ; then
-               result="${result}/${mask}"
-           fi
-       done
-    fi
-    if [ -z "$result" ] ; then 
-       echo "vserverIfconfig failed to locate $ifname"
-       exit 1
-    else
-       echo $result
-    fi
-}
-
-function usage () {
-    set +x 
-    echo "Usage: $COMMAND_VBUILD [options] vserver-name [ -- vserver-options ]"
-    echo "Usage: $COMMAND_MYPLC [options] vserver-name repo-url [ -- vserver-options ]"
-    echo "Requirements: you need to have a vserver-compliant kernel,"
-    echo "   as well as the util-vserver RPM installed"
-    echo "Description:"
-    echo "   This command creates a fresh vserver instance, for building, or running, myplc"
-    echo "Supported options"
-    echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
-    echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
-    echo " -p personality - defaults to $DEFAULT_PERSONALITY"
-    echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the vserver"
-    echo " -r : set apps/init/mark to default so the vserver restart upon reboot"
-    echo " -v : verbose - passes -v to calls to vserver"
-    echo "vserver-options"
-    echo "  all args after the optional -- are passed to vserver <name> build <options>"
-    echo "  typical usage is e.g. --interface eth0:200.150.100.10/24"
-    echo "With $COMMAND_MYPLC you can give 'none' as the URL, in which case"
-    echo "   myplc.repo does not get created"
-    exit 1
-}
-
-### parse args and 
-function main () {
-
-    set -e
-    trap failure ERR INT
-
-    case "$COMMAND" in
-       $COMMAND_VBUILD)
-           VBUILD_MODE=true ;;
-       $COMMAND_MYPLC)
-           MYPLC_MODE=true;;
-       *)
-           usage ;;
-    esac
-
-    VERBOSE=
-    RESISTANT=""
-    IFNAME=""
-    VSERVER_OPTIONS=""
-
-    # the set of preinstalled packages - depends on vbuild or vtest
-    if [ -n "$VBUILD_MODE" ] ; then
-       PREINSTALLED=devel.pkgs
-    else
-       PREINSTALLED=vtest.pkgs
-    fi
-    while getopts "f:d:p:P:i:rv" opt ; do
-       case $opt in
-           f) fcdistro=$OPTARG;;
-           d) pldistro=$OPTARG;;
-           p) personality=$OPTARG;;
-           P) PREINSTALLED=$OPTARG;;
-           i) IFNAME=$OPTARG;;
-           r) RESISTANT="true";;
-           v) VERBOSE="-v" ;;
-           *) usage ;;
-       esac
-    done
-       
-    shift $(($OPTIND - 1))
-
-    # parse fixed arguments
-    [[ -z "$@" ]] && usage
-    vserver=$1 ; shift
-    if [ -n "$MYPLC_MODE" ] ; then
-       [[ -z "$@" ]] && usage
-       REPO_URL=$1 ; shift
-    fi
-
-    # parse vserver options
-    if [[ -n "$@" ]] ; then
-       if [ "$1" == "--" ] ; then
-           shift
-           VSERVER_OPTIONS="$@"
-       else
-           usage
-       fi
-    fi
-
-    # with new util-vserver, it is mandatory to provide an IP even for building
-    if [ -n "$VBUILD_MODE" ] ; then
-       [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
-    fi
-    if [ -n "$IFNAME" ] ; then
-       localip=$(vserverIfconfig $IFNAME)
-       VSERVER_OPTIONS="$VSERVER_OPTIONS --interface $localip"
-    fi
-
-    [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
-    [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
-    [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
-
-    setup_vserver $vserver $fcdistro $pldistro $personality 
-    devel_or_vtest_tools $vserver $fcdistro $pldistro $personality
-    post_install $vserver $personality
-
-    # Start Vserver automatically on boot
-    [ -n "$RESISTANt" ] && echo "default" > /etc/vservers/$vserver/apps/init/mark
-
-    echo $COMMAND Done
-}
-
-main "$@"
diff --git a/vbuild-nightly.sh b/vbuild-nightly.sh
deleted file mode 100755 (executable)
index 27af613..0000000
+++ /dev/null
@@ -1,761 +0,0 @@
-#!/bin/bash
-
-COMMANDPATH=$0
-COMMAND=$(basename $0)
-
-# default values, tunable with command-line options
-DEFAULT_FCDISTRO=f14
-DEFAULT_PLDISTRO=planetlab
-DEFAULT_PERSONALITY=linux64
-DEFAULT_BASE="@DATE@--@PLDISTRO@-@FCDISTRO@-@PERSONALITY@"
-DEFAULT_BUILD_SCM_URL="git://git.onelab.eu/build"
-DEFAULT_IFNAME=eth0
-
-# default gpg path used in signing yum repo
-DEFAULT_GPGPATH="/etc/planetlab"
-# default email to use in gpg secring
-DEFAULT_GPGUID="root@$( /bin/hostname )"
-
-DEFAULT_TESTCONFIG="default"
-# for passing args to run_log
-RUN_LOG_EXTRAS=""
-
-# for publishing results, and the tests settings
-x=$(hostname)
-y=$(hostname|sed -e s,inria,,)
-# INRIA defaults
-if [ "$x" != "$y" ] ; then
-    DEFAULT_WEBPATH="/build/@PLDISTRO@/"
-    DEFAULT_TESTBUILDURL="http://build.onelab.eu/"
-    # this is where the buildurl is pointing towards
-    DEFAULT_WEBROOT="/build/"
-    DEFAULT_TESTMASTER="testmaster.onelab.eu"
-else
-    DEFAULT_WEBPATH="/build/@FCDISTRO@/@PLDISTRO@/"
-    DEFAULT_TESTBUILDURL="http://build.planet-lab.org/"
-    # this is where the buildurl is pointing towards
-    DEFAULT_WEBROOT="/build/"
-    DEFAULT_TESTMASTER="manager.test.planet-lab.org"
-fi    
-
-####################
-# assuming vserver runs in UTC
-DATE=$(date +'%Y.%m.%d')
-
-# temporary - wrap a quick summary of suspicious stuff
-# this is to focus on installation that go wrong
-# use with care, a *lot* of other things can go bad as well
-function summary () {
-    from=$1; shift
-    echo "******************** BEG SUMMARY" 
-    python - $from <<EOF
-#!/usr/bin/env python
-# read a full log and tries to extract the interesting stuff
-
-import sys,re
-m_show_line=re.compile(".* (BEG|END) (RPM|VSERVER).*|.*'boot'.*|\* .*| \* .*|.*is not installed.*|.*PROPFIND.*|.* (BEG|END).*:run_log.*|.* Within vserver (BEG|END) .*|.* MAIN (BEG|END).*")
-m_installing_any=re.compile('\r  (Installing:[^\]]*]) ')
-m_installing_err=re.compile('\r  (Installing:[^\]]*])(..+)')
-m_installing_end=re.compile('Installed:.*')
-m_installing_doc1=re.compile("(.*)install-info: No such file or directory for /usr/share/info/\S+(.*)")
-m_installing_doc2=re.compile("(.*)grep: /usr/share/info/dir: No such file or directory(.*)")
-
-def summary (filename):
-
-    try:
-        if filename=="-":
-            filename="stdin"
-            f=sys.stdin
-        else:
-            f=open(filename)
-        echo=False
-        for line in f.xreadlines():
-            # first off : discard warnings related to doc
-            if m_installing_doc1.match(line):
-                (begin,end)=m_installing_doc1.match(line).groups()
-                line=begin+end
-            if m_installing_doc2.match(line):
-                (begin,end)=m_installing_doc2.match(line).groups()
-                line=begin+end
-            # unconditionnally show these lines
-            if m_show_line.match(line):
-                print '>>>',line,
-            # an 'installing' line with messages afterwards : needs to be echoed
-            elif m_installing_err.match(line):
-                (installing,error)=m_installing_err.match(line).groups()
-                print '>>>',installing
-                print '>>>',error
-                echo=True
-            # closing an 'installing' section
-            elif m_installing_end.match(line):
-                echo=False
-            # any 'installing' line
-            elif m_installing_any.match(line):
-                if echo: 
-                    installing=m_installing_any.match(line).group(1)
-                    print '>>>',installing
-                echo=False
-            # print lines when echo is true
-            else:
-                if echo: print '>>>',line,
-        f.close()
-    except:
-        print 'Failed to analyze',filename
-
-for arg in sys.argv[1:]:
-    summary(arg)
-EOF
-    echo "******************** END SUMMARY" 
-}
-
-### we might build on a box other than the actual web server
-# utilities for handling the pushed material (rpms, logfiles, ...)
-function webpublish_misses_dir () { ssh root@${WEBHOST}  "bash -c \"test \! -d $1\"" ; }
-function webpublish () { ssh root@${WEBHOST} "$@" ; }
-function webpublish_cp_local_to_remote () { scp $1 root@${WEBHOST}:$2 ; }
-function webpublish_cp_stdin_to_file () { ssh root@${WEBHOST} cat \> $1; }
-function webpublish_append_stdin_to_file () { ssh root@${WEBHOST} cat \>\> $1; }
-# provide remote dir as first argument, so any number of local files can be passed next
-function webpublish_rsync_dir () { rsync --archive --delete $VERBOSE $2 root@${WEBHOST}:$1 ; }
-function webpublish_rsync_files () {
-    remote="$1"; shift
-    rsync --archive $VERBOSE "$@" root@${WEBHOST}:"$remote" ;
-}
-
-# Notify recipient of failure or success, manage various stamps 
-function failure() {
-    set -x
-    # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
-       WEBPATH=/tmp
-       WEBBASE=/tmp/vbuild-early-$(date +%Y-%m-%d)
-       WEBLOG=/tmp/vbuild-early-$(date +%Y-%m-%d).log.txt
-    fi
-    webpublish mkdir -p $WEBBASE ||:
-    webpublish_cp_local_to_remote $LOG $WEBLOG ||:
-    summary $LOG | webpublish_append_stdin_to_file $WEBLOG ||:
-    (echo -n "============================== $COMMAND: failure at " ; date ; \
-       webpublish tail --lines=1000 $WEBLOG) | \
-       webpublish_cp_stdin_to_file $WEBBASE.ko ||:
-    if [ -n "$MAILTO" ] ; then
-       ( \
-           echo "Subject: KO ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
-           echo "see build results at        $WEBBASE_URL" ; \
-           echo "including full build log at $WEBBASE_URL/log.txt" ; \
-           echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
-           echo "........................................" ; \
-           webpublish tail --lines=1000 $WEBLOG ) | \
-           sendmail $MAILTO
-    fi
-    exit 1
-}
-
-function success () {
-    set -x
-    # early stage ? - let's not create /build/@PLDISTRO@
-    if test -z "$WEBLOG" ; then
-       WEBHOST=$(hostname)
-       WEBPATH=/tmp
-       WEBLOG=/tmp/vbuild-early-$(date +%Y-%m-%d).log.txt
-    fi
-    webpublish mkdir -p $WEBBASE
-    webpublish_cp_local_to_remote $LOG $WEBLOG
-    summary $LOG | webpublish_append_stdin_to_file $WEBLOG
-    if [ -n "$DO_TEST" ] ; then
-       short_message="PASS"
-       ( \
-           echo "Successfully built and tested" ; \
-           echo "see build results at        $WEBBASE_URL" ; \
-           echo "including full build log at $WEBBASE_URL/log.txt" ; \
-           echo "and complete test logs at   $WEBBASE_URL/testlogs" ; \
-           ) | webpublish_cp_stdin_to_file $WEBBASE.pass
-       webpublish rm -f $WEBBASE.pkg-ok $WEBBASE.ko
-    else
-       short_message="PKGOK"
-       ( \
-           echo "Successful package-only build, no test requested" ; \
-           echo "see build results at        $WEBBASE_URL" ; \
-           echo "including full build log at $WEBBASE_URL/log.txt" ; \
-           ) | webpublish_cp_stdin_to_file $WEBBASE.pkg-ok
-       webpublish rm -f $WEBBASE.ko
-    fi
-    if [ -n "$MAILTO" ] ; then
-       ( \
-           echo "Subject: $short_message ${BASE} ${MAIL_SUBJECT}" ; \
-           echo "To: $MAILTO" ; \
-           echo "$PLDISTRO ($BASE) build for $FCDISTRO completed on $(date)" ; \
-           echo "see build results at        $WEBBASE_URL" ; \
-           echo "including full build log at $WEBBASE_URL/log.txt" ; \
-            [ -n "$DO_TEST" ] && echo "and complete test logs at   $WEBBASE_URL/testlogs" ) \
-           | sendmail $MAILTO
-    fi
-    # XXX For some reason, we haven't been getting this email for successful builds. If this sleep
-    # doesn't fix the problem, I'll remove it -- Sapan.
-    sleep 5
-    exit 0
-}
-
-# run in the vserver - do not manage success/failure, will be done from the root ctx
-function build () {
-    set -x
-    set -e
-
-    echo -n "============================== Starting $COMMAND:build on "
-    date
-
-    cd /build
-    show_env
-    
-    echo "Running make IN $(pwd)"
-    
-    # stuff our own variable settings
-    if echo $BUILD_SCM_URL | grep -q git ; then
-       MAKEVARS=("build-GITPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
-    else
-       MAKEVARS=("build-SVNPATH=${BUILD_SCM_URL}" "${MAKEVARS[@]}")
-    fi
-    MAKEVARS=("PLDISTRO=${PLDISTRO}" "${MAKEVARS[@]}")
-    MAKEVARS=("PLDISTROTAGS=${PLDISTROTAGS}" "${MAKEVARS[@]}")
-    MAKEVARS=("PERSONALITY=${PERSONALITY}" "${MAKEVARS[@]}")
-    MAKEVARS=("MAILTO=${MAILTO}" "${MAKEVARS[@]}")
-    MAKEVARS=("WEBPATH=${WEBPATH}" "${MAKEVARS[@]}")
-    MAKEVARS=("TESTBUILDURL=${TESTBUILDURL}" "${MAKEVARS[@]}")
-    MAKEVARS=("WEBROOT=${WEBROOT}" "${MAKEVARS[@]}")
-
-    MAKEVARS=("BASE=${BASE}" "${MAKEVARS[@]}")
-
-    # initialize latex
-    /build/latex-first-run.sh || :
-
-    # stage1
-    make -C /build $DRY_RUN "${MAKEVARS[@]}" stage1=true 
-    # versions
-    make -C /build $DRY_RUN "${MAKEVARS[@]}" versions
-    # actual stuff
-    make -C /build $DRY_RUN "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
-
-}
-
-# this was formerly run in the myplc-devel chroot but now is run in the root context,
-# this is so that the .ssh config gets done manually, and once and for all
-function run_log () {
-    set -x
-    set -e
-    trap failure ERR INT
-
-    echo "============================== BEG $COMMAND:run_log on $(date)"
-
-    ### the URL to the RPMS/<arch> location
-    # f12 now has everything in i686; try i386 first as older fedoras have both
-    url=""
-    for a in i386 i686 x86_64; do
-       archdir=/vservers/$BASE/build/RPMS/$a
-       if [ -d $archdir ] ; then
-           # where was that installed
-           url=$(echo $archdir | sed -e "s,/vservers/${BASE}/build,${WEBPATH}/${BASE},")
-           url=$(echo $url | sed -e "s,${WEBROOT},${TESTBUILDURL},")
-           break
-       fi
-    done
-
-    if [ -z "$url" ] ; then
-       echo "$COMMAND: Cannot locate arch URL for testing"
-       failure
-       exit 1
-    fi
-
-    testmaster_ssh="root@${TESTMASTER}"
-
-    # test directory name on test box
-    testdir=${BASE}
-
-    # clean it
-    ssh -n ${testmaster_ssh} rm -rf ${testdir} ${testdir}.git
-
-    # check it out in the build
-    vserver $BASE exec make -C /build tests-module
-    
-    # push it onto the testmaster - just the 'system' subdir is enough
-    rsync --verbose --archive /vservers/$BASE/build/MODULES/tests/system/ ${testmaster_ssh}:${BASE}
-    # toss the build in the bargain, so the tests don't need to mess with extracting it
-    rsync --verbose --archive /vservers/$BASE/build/MODULES/build ${testmaster_ssh}:${BASE}/
-
-    # invoke test on testbox - pass url and build url - so the tests can use vtest-initvm.sh
-    run_log_env="-p $PERSONALITY -d $PLDISTRO -f $FCDISTRO"
-
-    # need to proceed despite of set -e
-    success=true
-    # passing the build_scm_url should not be needed anymore
-    ssh 2>&1 -n ${testmaster_ssh} ${testdir}/run_log --build ${BUILD_SCM_URL} --url ${url} $run_log_env $RUN_LOG_EXTRAS $VERBOSE --all || success=
-
-    # gather logs in the build vserver
-    mkdir -p /vservers/$BASE/build/testlogs
-    rsync --verbose --archive ${testmaster_ssh}:$BASE/logs/ /vservers/$BASE/build/testlogs
-    # push them to the build web
-    chmod -R a+r /vservers/$BASE/build/testlogs/
-    webpublish_rsync_dir $WEBPATH/$BASE/testlogs/ /vservers/$BASE/build/testlogs/
-
-    echo  "============================== END $COMMAND:run_log on $(date)"
-
-    if [ -z "$success" ] ; then
-       echo "Tests have failed - bailing out"
-       failure
-    fi
-    
-}
-
-function in_root_context () {
-    rpm -q util-vserver > /dev/null 
-}
-
-# this part won't work if WEBHOST does not match the local host
-# would need to be made webpublish_* compliant
-# but do we really need this feature anyway ?
-function sign_node_packages () {
-
-    echo "Signing node packages"
-    
-    need_createrepo=""
-
-    repository=$WEBPATH/$BASE/RPMS/
-    # the rpms that need signing
-    new_rpms=
-    # and the corresponding stamps
-    new_stamps=
-
-    for package in $(find $repository/ -name '*.rpm') ; do
-        stamp=$repository/signed-stamps/$(basename $package).signed
-        # If package is newer than signature stamp
-        if [ $package -nt $stamp ] ; then
-            new_rpms="$new_rpms $package"
-            new_stamps="$new_stamps $stamp"
-        fi
-        # Or than createrepo database
-        [ $package -nt $repository/repodata/repomd.xml ] && need_createrepo=true
-    done
-
-    if [ -n "$new_rpms" ] ; then
-        # Create a stamp once the package gets signed
-        mkdir $repository/signed-stamps 2> /dev/null
-       
-        # Sign RPMS. setsid detaches rpm from the terminal,
-        # allowing the (hopefully blank) GPG password to be
-        # entered from stdin instead of /dev/tty.
-        echo | setsid rpm \
-            --define "_signature gpg" \
-            --define "_gpg_path $GPGPATH" \
-            --define "_gpg_name $GPGUID" \
-            --resign $new_rpms && touch $new_stamps
-    fi
-
-     # Update repository index / yum metadata. 
-    if [ -n "$need_createrepo" ] ; then
-       echo "Indexing node packages after signing"
-        if [ -f $repository/yumgroups.xml ] ; then
-            createrepo --quiet -g yumgroups.xml $repository
-        else
-            createrepo --quiet $repository
-        fi
-    fi
-}
-
-function show_env () {
-    set +x
-    echo FCDISTRO=$FCDISTRO
-    echo PLDISTRO=$PLDISTRO
-    echo PERSONALITY=$PERSONALITY
-    echo BASE=$BASE
-    echo BUILD_SCM_URL=$BUILD_SCM_URL
-    echo MAKEVARS="${MAKEVARS[@]}"
-    echo DRY_RUN="$DRY_RUN"
-    echo PLDISTROTAGS="$PLDISTROTAGS"
-    # this does not help, it's not yet set when we run show_env
-    #echo WEBPATH="$WEBPATH"
-    echo TESTBUILDURL="$TESTBUILDURL"
-    echo WEBHOST="$WEBHOST"
-    if in_root_context ; then
-       echo PLDISTROTAGS="$PLDISTROTAGS"
-    else
-       if [ -f /build/$PLDISTROTAGS ] ; then
-           echo "XXXXXXXXXXXXXXXXXXXX Contents of tags definition file /build/$PLDISTROTAGS"
-           cat /build/$PLDISTROTAGS
-           echo "XXXXXXXXXXXXXXXXXXXX end tags definition"
-       else
-           echo "XXXXXXXXXXXXXXXXXXXX Cannot find tags definition file /build/$PLDISTROTAGS, assuming remote pldistro"
-       fi
-    fi
-    set -x
-}
-
-function setupssh () {
-    base=$1; shift
-    sshkey=$1; shift
-    
-    if [ -f ${sshkey} ] ; then
-       SSHDIR=/vservers/${base}/root/.ssh
-       mkdir -p ${SSHDIR}
-       cp $sshkey ${SSHDIR}/thekey
-       (echo "host *"; \
-           echo "  IdentityFile ~/.ssh/thekey"; \
-           echo "  StrictHostKeyChecking no" ) > ${SSHDIR}/config
-       chmod 700 ${SSHDIR}
-       chmod 400 ${SSHDIR}/*
-    else 
-       echo "WARNING : could not find provided ssh key $sshkey - ignored"
-    fi
-}
-
-function usage () {
-    echo "Usage: $COMMAND [option] [var=value...] make-targets"
-    echo "Supported options"
-    echo " -f fcdistro - defaults to $DEFAULT_FCDISTRO"
-    echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
-    echo " -p personality - defaults to $DEFAULT_PERSONALITY"
-    echo " -m mailto - no default"
-    echo " -s build_scm_url - git or svn URL where to fetch the build module - defaults to $DEFAULT_BUILD_SCM_URL"
-    echo "    define GIT tag or branch name appending @tagname to url"
-    echo " -t pldistrotags - defaults to \${PLDISTRO}-tags.mk"
-    echo " -b base - defaults to $DEFAULT_BASE"
-    echo "    @NAME@ replaced as appropriate"
-    echo " -o base: (overwrite) do not re-create vserver, re-use base instead"
-    echo "    the -f/-d/-p/-m/-s/-t options are uneffective in this case"
-    echo " -c testconfig - defaults to $DEFAULT_TESTCONFIG"
-    echo " -y {pl,pg} - passed to run_log"
-    echo " -e step - passed to run_log"
-    echo " -X : passes --lxc to run_log"
-    echo " -S : passes --vs to run_log"
-    echo " -x <run_log_args> - a hook to pass other arguments to run_log"
-    echo " -w webpath - defaults to $DEFAULT_WEBPATH"
-    echo " -W testbuildurl - defaults to $DEFAULT_TESTBUILDURL; this is also used to get the hostname where to publish builds"
-    echo " -r webroot - defaults to $DEFAULT_WEBROOT - the fs point where testbuildurl actually sits"
-    echo " -M testmaster - defaults to $DEFAULT_TESTMASTER"
-    echo " -Y - sign yum repo in webpath"
-    echo " -g gpg_path - to the gpg secring used to sign rpms.  Defaults to $DEFAULT_GPGPATH" 
-    echo " -u gpg_uid - email used in secring. Defaults to $DEFAULT_GPGUID"
-    echo " -K svnsshkey - specify key to use when svn+ssh:// URLs are used for SVNPATH"
-    echo " -S - do not publish source rpms"
-    echo " -B - run build only"
-    echo " -T - run test only"
-    echo " -n - dry-run: -n passed to make - vserver gets created though - no mail sent"
-    echo " -v - be verbose"
-    echo " -7 - uses weekday-@FCDISTRO@ as base"
-    echo " -i ifname - defaults to $DEFAULT_IFNAME - used to determine local IP"
-    echo " --build-branch branch - build using the branch from build module"
-    exit 1
-}
-
-function main () {
-
-    set -e
-
-    # parse arguments
-    MAKEVARS=()
-    MAKETARGETS=()
-    DRY_RUN=
-    DO_BUILD=true
-    DO_TEST=true
-    PUBLISH_SRPMS=true
-    SSH_KEY=""
-    SIGNYUMREPO=""
-
-    OPTS_ORIG=$@
-    OPTS=$(getopt -o "f:d:p:m:s:t:b:o:c:y:e:XSx:w:W:r:M:Yg:u:K:SBTnv7i:P:h" -l "build-branch:" -- $@)
-    if [ $? != 0 ]
-    then
-        usage
-    fi
-    eval set -- "$OPTS"
-    while true; do
-       case $1 in
-           -f) FCDISTRO=$2; shift 2 ;;
-           -d) PLDISTRO=$2; shift 2 ;;
-           -p) PERSONALITY=$2; shift 2 ;;
-           -m) MAILTO=$2; shift 2 ;;
-           -s) BUILD_SCM_URL=$2; shift 2 ;;
-           -t) PLDISTROTAGS=$2; shift 2 ;;
-           -b) BASE=$2; shift 2 ;;
-           -o) OVERBASE=$2; shift 2 ;;
-           -c) TESTCONFIG="$TESTCONFIG $2"; shift 2 ;;
-           ########## passing stuff to run_log
-           # -y foo -> run_log -y foo
-           -y) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --rspec-style $2"; shift 2 ;;
-           # -e foo -> run_log -e foo
-           -e) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --exclude $2"; shift 2 ;;
-           # -X -> run_log --lxc
-           -X) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --lxc"; shift;;
-           # -S -> run_log --vs
-           -S) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --vs"; shift;;
-           # more general form to pass args to run_log
-           # -x foo -> run_log foo
-           -x) RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS $2"; shift 2;;
-           ##########
-           -w) WEBPATH=$2; shift 2 ;;
-           -W) TESTBUILDURL=$2; shift 2 ;;
-           -r) WEBROOT=$2; shift 2 ;;
-           -M) TESTMASTER=$2; shift 2 ;;
-            -Y) SIGNYUMREPO=true; shift ;;
-            -g) GPGPATH=$2; shift 2 ;;
-            -u) GPGUID=$2; shift 2 ;;
-           -K) SSH_KEY=$2; shift 2 ;;
-           -S) PUBLISH_SRPMS="" ; shift ;;
-           -B) DO_TEST= ; shift ;;
-           -T) DO_BUILD= ; shift;;
-           -n) DRY_RUN="-n" ; shift ;;
-           -v) set -x ; VERBOSE="-v" ; shift ;;
-           -7) BASE="$(date +%a|tr A-Z a-z)-@FCDISTRO@" ; shift ;;
-           -i) IFNAME=$2; shift 2 ;;
-           -P) PREINSTALLED="-P $2"; shift 2;;
-           -h) usage ; shift ;;
-            --) shift; break ;;
-       esac
-    done
-
-    # preserve options for passing them again later, together with expanded base
-    options=$OPTS_ORIG
-
-    # allow var=value stuff; 
-    for target in "$@" ; do
-       # check if contains '='
-       target1=$(echo $target | sed -e s,=,,)
-       if [ "$target" = "$target1" ] ; then
-           MAKETARGETS=(${MAKETARGETS[@]} "$target")
-       else
-           MAKEVARS=(${MAKEVARS[@]} "$target")
-       fi
-    done
-    
-    # set defaults
-    [ -z "$FCDISTRO" ] && FCDISTRO=$DEFAULT_FCDISTRO
-    [ -z "$PLDISTRO" ] && PLDISTRO=$DEFAULT_PLDISTRO
-    [ -z "$PERSONALITY" ] && PERSONALITY=$DEFAULT_PERSONALITY
-    [ -z "$PLDISTROTAGS" ] && PLDISTROTAGS="${PLDISTRO}-tags.mk"
-    [ -z "$BASE" ] && BASE="$DEFAULT_BASE"
-    [ -z "$WEBPATH" ] && WEBPATH="$DEFAULT_WEBPATH"
-    [ -z "$TESTBUILDURL" ] && TESTBUILDURL="$DEFAULT_TESTBUILDURL"
-    [ -z "$WEBROOT" ] && WEBROOT="$DEFAULT_WEBROOT"
-    [ -z "$GPGPATH" ] && GPGPATH="$DEFAULT_GPGPATH"
-    [ -z "$GPGUID" ] && GPGUID="$DEFAULT_GPGUID"
-    [ -z "$IFNAME" ] && IFNAME="$DEFAULT_IFNAME"
-    [ -z "$BUILD_SCM_URL" ] && BUILD_SCM_URL="$DEFAULT_BUILD_SCM_URL"
-    [ -z "$TESTCONFIG" ] && TESTCONFIG="$DEFAULT_TESTCONFIG"
-    [ -z "$TESTMASTER" ] && TESTMASTER="$DEFAULT_TESTMASTER"
-
-    [ -n "$DRY_RUN" ] && MAILTO=""
-
-    # elaborate the extra args to be passed to run_log
-    for config in ${TESTCONFIG} ; do
-       RUN_LOG_EXTRAS="$RUN_LOG_EXTRAS --config $config"
-    done
-    
-       
-    if [ -n "$OVERBASE" ] ; then
-       sedargs="-e s,@DATE@,${DATE},g"
-       BASE=$(echo ${OVERBASE} | sed $sedargs)
-    else
-       sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
-       BASE=$(echo ${BASE} | sed $sedargs)
-    fi
-
-    ### elaborate mail subject
-    if [ -n "$DO_BUILD" -a -n "$DO_TEST" ] ; then
-       MAIL_SUBJECT="full"
-    elif [ -n "$DO_BUILD" ] ; then
-       MAIL_SUBJECT="pkg-only"
-    elif [ -n "$DO_TEST" ] ; then
-       MAIL_SUBJECT="test-only"
-    fi
-    if [ -n "$OVERBASE" ] ; then
-       MAIL_SUBJECT="${MAIL_SUBJECT} rerun"
-    else
-       MAIL_SUBJECT="${MAIL_SUBJECT} fresh"
-    fi
-    short_hostname=$(hostname | cut -d. -f1)
-    MAIL_SUBJECT="on ${short_hostname} - ${MAIL_SUBJECT}"
-
-    ### compute WEBHOST from TESTBUILDURL 
-    # this is to avoid having to change the builds configs everywhere
-    # simplistic way to extract hostname from a URL
-    WEBHOST=$(echo "$TESTBUILDURL" | cut -d/ -f 3)
-
-    if ! in_root_context ; then
-        # in the vserver
-       echo "==================== Within vserver BEG $(date)"
-       build
-       echo "==================== Within vserver END $(date)"
-
-    else
-       trap failure ERR INT
-        # we run in the root context : 
-        # (*) create or check for the vserver to use
-        # (*) copy this command in the vserver
-        # (*) invoke it
-       
-       if [ -n "$OVERBASE" ] ; then
-            ### Re-use a vserver (finish an unfinished build..)
-           if [ ! -d /vservers/${BASE} ] ; then
-               echo $COMMAND : cannot find vserver $BASE
-               exit 1
-           fi
-           # manage LOG - beware it might be a symlink so nuke it first
-           LOG=/vservers/${BASE}.log.txt
-           rm -f $LOG
-           exec > $LOG 2>&1
-           set -x
-           echo "XXXXXXXXXX $COMMAND: using existing vserver $BASE" $(date)
-           # start in case e.g. we just rebooted
-           vserver ${BASE} start || :
-           # retrieve environment from the previous run
-           FCDISTRO=$(vserver ${BASE} exec /build/getdistroname.sh)
-           BUILD_SCM_URL=$(vserver ${BASE} exec make --no-print-directory -C /build stage1=skip +build-SVNPATH +build-GITPATH)
-           # for efficiency, crop everything in one make run
-           tmp=/tmp/${BASE}-env.sh
-           vserver ${BASE} exec make --no-print-directory -C /build stage1=skip \
-               ++PLDISTRO ++PLDISTROTAGS ++PERSONALITY ++MAILTO ++WEBPATH ++TESTBUILDURL ++WEBROOT > $tmp
-           . $tmp
-           rm -f $tmp
-           # update build
-           [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           if echo $BUILD_SCM_URL | grep -q git ; then
-               vserver $BASE exec bash -c "cd /build; git pull; make tests-clean"
-           else
-               vserver $BASE exec svn update /build
-           fi
-           # make sure we refresh the tests place in case it has changed
-           rm -f /build/MODULES/tests
-           options=(${options[@]} -d $PLDISTRO -t $PLDISTROTAGS -s $BUILD_SCM_URL)
-           [ -n "$PERSONALITY" ] && options=(${options[@]} -p $PERSONALITY)
-           [ -n "$MAILTO" ] && options=(${options[@]} -m $MAILTO)
-           [ -n "$WEBPATH" ] && options=(${options[@]} -w $WEBPATH)
-           [ -n "$TESTBUILDURL" ] && options=(${options[@]} -W $TESTBUILDURL)
-           [ -n "$WEBROOT" ] && options=(${options[@]} -r $WEBROOT)
-           show_env
-       else
-           # create vserver: check it does not exist yet
-           i=
-           while [ -d /vservers/${BASE}${i} ] ; do
-               # we name subsequent builds <base>-n<i> so the logs and builds get sorted properly
-               [ -z ${i} ] && BASE=${BASE}-n
-               i=$((${i}+1))
-               if [ $i -gt 100 ] ; then
-                   echo "$COMMAND: Failed to create build vserver /vservers/${BASE}${i}"
-                   exit 1
-               fi
-           done
-           BASE=${BASE}${i}
-           # need update
-           # manage LOG - beware it might be a symlink so nuke it first
-           LOG=/vservers/${BASE}.log.txt
-           rm -f $LOG
-           exec > $LOG 2>&1 
-           set -x
-           echo "XXXXXXXXXX $COMMAND: creating vserver $BASE" $(date)
-           show_env
-
-           ### extract the whole build - much simpler
-           tmpdir=/tmp/$COMMAND-$$
-           if echo $BUILD_SCM_URL | grep -q git ; then
-               GIT_REPO=$(echo $BUILD_SCM_URL | cut -d@ -f1)
-               GIT_TAG=$(echo $BUILD_SCM_URL | cut -s -d@ -f2)
-               GIT_TAG=${GIT_TAG:-master}
-               mkdir -p $tmpdir; git archive --remote=$GIT_REPO $GIT_TAG | tar -C $tmpdir -xf -
-           else
-               svn export $BUILD_SCM_URL $tmpdir
-           fi
-            # Create vserver
-           cd $tmpdir
-           ./vbuild-initvm.sh $VERBOSE -f ${FCDISTRO} -d ${PLDISTRO} -p ${PERSONALITY} -i ${IFNAME} ${PREINSTALLED} ${BASE} 
-           # cleanup
-           cd -
-           rm -rf $tmpdir
-           # Extract build again - in the vserver
-           [ -n "$SSH_KEY" ] && setupssh ${BASE} ${SSH_KEY}
-           if echo $BUILD_SCM_URL | grep -q git ; then
-               vserver $BASE exec bash -c "git clone $GIT_REPO /build; cd /build; git checkout $GIT_TAG"
-           else
-               vserver $BASE exec svn checkout ${BUILD_SCM_URL} /build
-           fi
-       fi
-       # install ssh key in vserver
-       echo "XXXXXXXXXX $COMMAND: preparation of vserver $BASE done" $(date)
-
-       # The log inside the vserver contains everything
-       LOG2=/vservers/${BASE}/log.txt
-       (echo "==================== BEG VSERVER Transcript of vserver creation" ; \
-        cat $LOG ; \
-        echo "==================== END VSERVER Transcript of vserver creation" ; \
-        echo "xxxxxxxxxx Messing with logs, symlinking $LOG2 to $LOG" ) >> $LOG2
-       ### not too nice : nuke the former log, symlink it to the new one
-       rm $LOG; ln -s $LOG2 $LOG
-       LOG=$LOG2
-       # redirect log again
-       exec >> $LOG 2>&1 
-
-       sedargs="-e s,@DATE@,${DATE},g -e s,@FCDISTRO@,${FCDISTRO},g -e s,@PLDISTRO@,${PLDISTRO},g -e s,@PERSONALITY@,${PERSONALITY},g"
-       WEBPATH=$(echo ${WEBPATH} | sed $sedargs)
-       webpublish mkdir -p ${WEBPATH}
-
-        # where to store the log for web access
-       WEBBASE=${WEBPATH}/${BASE}
-       WEBLOG=${WEBPATH}/${BASE}/log.txt
-        # compute the log URL - inserted in the mail messages for convenience
-       WEBBASE_URL=$(echo $WEBBASE | sed -e "s,//,/,g" -e "s,${WEBROOT},${TESTBUILDURL},")
-    
-       if [ -n "$DO_BUILD" ] ; then 
-
-           # invoke this command into the build directory of the vserver
-           cp $COMMANDPATH /vservers/${BASE}/build/
-
-           # invoke this command in the vserver for building (-T)
-           vserver ${BASE} exec chmod +x /build/$COMMAND
-           vserver ${BASE} exec /build/$COMMAND "${options[@]}" -b "${BASE}" "${MAKEVARS[@]}" "${MAKETARGETS[@]}"
-       fi
-
-       # publish to the web so run_log can find them
-       set +e
-       webpublish rm -rf $WEBPATH/$BASE 
-       # guess if we've been doing any debian-related build
-       if [ ! -f /vservers/$BASE/etc/debian_version  ] ; then
-           webpublish mkdir -p $WEBPATH/$BASE/{RPMS,SRPMS}
-           webpublish_rsync_dir $WEBPATH/$BASE/RPMS/ /vservers/$BASE/build/RPMS/
-           [[ -n "$PUBLISH_SRPMS" ]] && webpublish_rsync_dir $WEBPATH/$BASE/SRPMS/ /vservers/$BASE/build/SRPMS/
-       else
-           # run scanpackages so we can use apt-get on this
-           # (not needed on fedora b/c this is done by the regular build already)
-           vserver $BASE exec bash -c "(cd /build ; dpkg-scanpackages DEBIAN/ | gzip -9c > Packages.gz)"
-           webpublish mkdir -p $WEBPATH/$BASE/DEBIAN
-           webpublish_rsync_files $WEBPATH/$BASE/DEBIAN/ /vservers/$BASE/build/DEBIAN/*.deb 
-           webpublish_rsync_files $WEBPATH/$BASE/ /vservers/$BASE/build/Packages.gz
-       fi
-       # publish myplc-release if this exists
-       release=/vservers/$BASE/build/myplc-release
-       [ -f $release ] && webpublish_rsync_files $WEBPATH/$BASE $release
-       set -e
-
-        # create yum repo and sign packages.
-       if [ -n "$SIGNYUMREPO" ] ; then
-           # this script does not yet support signing on a remote (webhost) repo
-           sign_here=$(hostname) ; sign_web=$(webpublish hostname)
-           if [ "$hostname" = "$sign_here" ] ; then
-               sign_node_packages
-           else
-               echo "$COMMAND does not support signing on a remote yum repo"
-               echo "you might want to turn off the -y option, or run this on the web server box itself"
-               exit 1
-           fi
-       fi
-
-       if [ -n "$DO_TEST" ] ; then 
-           run_log
-       fi
-
-       success 
-
-        echo "==================== MAIN END $(date)"   
-    fi
-
-}  
-
-##########
-main "$@"